%{
  open Input

%}

%token EOF
%token LBRACE RBRACE
%token AND OR ARROW
%token VDASH
%token SEP STOUP_SEP
%token <int> TYPE
%type <Input.prop list * Input.prop option * Input.prop> pb
%start pb
%right ARROW
%nonassoc AND OR
%%

pb:
| env VDASH prop { $1, None, $3 }
| env STOUP_SEP stoup VDASH prop { $1, $3, $5 }

stoup:
| { None }
| prop { Some $1 }

env:
| { [] }
| fenv { $1 }

fenv:
| prop { [$1] }
| prop SEP env { $1 :: $3 }

prop:
| TYPE { PVar $1 }
| LBRACE prop RBRACE { $2 }
| prop AND prop { And [$1;$3] }
| prop OR  prop { Or(0, [$1;$3]) }
| prop ARROW prop { Arrow ($1,$3) } 
