open Count
open ExtList

module Build (LJT : LJT.LJTSig) = struct
open Paths
open LJT

(* Not really pretty but it works ; TODO *)
let numerotate_cont l =
  let rec aux oldp i = function
    | [] -> []
    | Cont (p, _) as c :: q ->
        if oldp = Some p then
          (c, i) :: aux oldp (i+1) q
        else
          (c, 0) :: aux (Some p) 1 q
    | t :: q -> (t, 0) :: aux None 0 q
  in aux None 0 l

let rec walk_problem ?(check_nb_proofs=true) ncycles pb = 
  try 
    let node = retrieve_problem_node pb in
      if node.nb_visits > ncycles || 
        (check_nb_proofs && node.nb_proofs = `AllFound Zero) then []
      else (
        node.nb_visits <- node.nb_visits + 1;
        let r = List.flatten 
                  (List.map (walk_node_rules ~check_nb_proofs ncycles)
                     (numerotate_cont node.hypotheses)) in
          node.nb_visits <- node.nb_visits - 1;
          node.proofs_paths <- r@node.proofs_paths;
          r)
  with Not_found -> []
and walk_node_rules ?(check_nb_proofs=true) ncycles = function
  | Ax, _ -> [ax]
  | Cont (prop, p), i -> 
      List.map (cont prop i) (walk_problem ~check_nb_proofs ncycles p)
  | ImpL (p1, p2), _ -> 
      List.map impl (List.cartesian (walk_problem ~check_nb_proofs ncycles p1)
                               (walk_problem ~check_nb_proofs ncycles p2))
  | ImpR p, _ -> List.map impr (walk_problem ~check_nb_proofs ncycles p)
  | AndL (i, p), _ -> 
      List.map (andl i) (walk_problem ~check_nb_proofs ncycles p)
  | AndR l, _ -> List.map andr 
      (List.distribute (List.map (walk_problem ~check_nb_proofs ncycles) l))
  | OrL (i, l), _ -> List.map (orl i)
      (List.distribute (List.map (walk_problem ~check_nb_proofs ncycles) l))
  | OrR (i, i', p), _ ->
      List.map (orr i i') (walk_problem ~check_nb_proofs ncycles p)

end
