open State
type t =
    ConditionalMove of reg * reg * reg
  | ArrayIndex of reg * reg * reg
  | ArrayAmendment of reg * reg * reg
  | Addition of reg * reg * reg
  | Multiplication of reg * reg * reg
  | Division of reg * reg * reg
  | NotAnd of reg * reg * reg
  | Halt
  | Allocation of reg * reg
  | Abandonment of reg
  | Output of reg
  | Input of reg
  | LoadProgram of reg * reg
  | Orthography of reg * int32

val of_int32 : int32 -> t
val to_int32 : t -> int32
val to_string : t -> string
val print : Format.formatter -> t -> unit
val pretty_print : Format.formatter -> t -> unit
