type t = int32

type reg = int (* 0..7 *)

type state

type block = Block.t

val get_reg: state -> reg -> t
val set_reg: state -> reg -> t -> unit

val get_array: state -> t -> block
val alloc_array: state -> t -> t
val free_array: state -> t -> unit

val init: in_channel -> state

val fetch_instr: state -> t
val dump: Format.formatter -> state -> unit

val load: state -> t -> t -> unit

val save_state: string -> state -> unit
val load_state: string -> state
val id : string


val gc: state -> unit
